> For the complete documentation index, see [llms.txt](https://docs.citrea.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.citrea.xyz/developer-documentation/ecosystem-tooling/rpc-indexers.md).

# RPC & Indexers

## RPC Providers

Citrea provides free RPC endpoints for developers to use: <https://rpc.mainnet.citrea.xyz> and <https://rpc.testnet.citrea.xyz>. For small projects & simple queries, you may use this endpoint safely as it offers generous rate limits.

However, for larger projects or production use, we recommend [setting up your own RPC node](https://docs.citrea.xyz/developer-documentation/run-a-node) or a dedicated RPC provider.

### Alchemy

[Alchemy](https://www.alchemy.com/docs/reference/citrea-api-quickstart?utm_source=chain_partner\&utm_medium=referral\&utm_campaign=citrea) is a high-performance RPC provider that offers a generous free tier and stronger paid plans for higher usage for Citrea. You may refer to their [webpage](https://www.alchemy.com/pricing?utm_source=chain_partner\&utm_medium=referral\&utm_campaign=citrea) for more details on the usage.

***

## Indexers

### Goldsky

[Goldsky](https://goldsky.com/) is a Web3-native, real-time data platform that lets you index and query on-chain data without wrangling infrastructure. Built for effortless scale and backed by 24 × 7 support, it frees you to ship features instead of managing servers.

Citrea supports both [Goldsky Subgraphs](https://docs.goldsky.com/subgraphs/introduction) and [Goldsky Mirrors](https://docs.goldsky.com/mirror/introduction). Subgraphs provide high-performance, custom-modeled queries with smart tagging for precise filtering for your development, and Mirrors stream live blockchain events straight into your own database and keep data continuously in sync.

As a developer building on Citrea, you can utilize Goldsky products at a discount. Check out the Citrea page on their [documentation](https://docs.goldsky.com/chains/citrea?utm_source=citrea\&utm_medium=docs) for more information and kickstart your development!

*Note*: The correct Citrea slug for Goldsky is `citrea-testnet-tangerine` for testnet, and `citrea` for mainnet.

### Envio

[Envio](https://envio.dev) is a super-fast data platform on Citrea with HyperIndex and HyperSync support.

Using [Envio HyperIndex](https://docs.envio.dev/docs/HyperIndex/overview) you can transform on-chain events into structured, queryable databases with GraphQL APIs.

[Envio HyperSync](https://docs.envio.dev/docs/HyperSync/overview) is Envio's high-performance blockchain data engine that serves as a direct replacement for traditional RPCs for read-only endpoints, delivering up to 2000x faster data access.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.citrea.xyz/developer-documentation/ecosystem-tooling/rpc-indexers.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
